LeetCode278:First Bad Version(二分法)

You are a product manager and currently leading a team to develop a new product. Unfortunately, the latest version of your product fails the quality check. Since each version is developed based on the previous version, all the versions after a bad version are also bad.

Suppose you have n versions [1, 2, ..., n] and you want to find out the first bad one, which causes all the following ones to be bad.

You are given an API bool isBadVersion(version) which will return whether version is bad. Implement a function to find the first bad version. You should minimize the number of calls to the API.

Example:

Given n = 5, and version = 4 is the first bad version.

call isBadVersion(3) -> false
call isBadVersion(5) -> true
call isBadVersion(4) -> true

Then 4 is the first bad version. 

LeetCode:链接

可以用暴力搜索,但是因为他要求少用判断的次数,所以对于有序数组来说二分法是最好的选择。

# The isBadVersion API is already defined for you.
# @param version, an integer
# @return a bool
# def isBadVersion(version):

class Solution(object):
    def firstBadVersion(self, n):
        """
        :type n: int
        :rtype: int
        """
        low = 1
        high = n
        while low <= high:
            mid = (low+high) // 2
            if isBadVersion(mid) == True:
                high = mid - 1
            else:
                low = mid + 1
        return low

猜你喜欢

转载自blog.csdn.net/mengmengdajuanjuan/article/details/84134911